<?php
/*
Plugin Name: CWD 3D Image Gallery
Plugin URI: http://www.coralwebdesigns.com/
Version: 1.0
Author: Coral Web Design
Description: A plugin to display images in 3d view
*/

session_start();

function cwd_create_gallery()
{
    global $wpdb;

    $image_gallery_details = $wpdb->prefix . 'image_3d';

    $query = 'create table if not exists ' .$image_gallery_details. '(
            id int NOT NULL AUTO_INCREMENT,
            galleryname varchar(50) NOT NULL,
            width int(5) NOT NULL,
            height int(5) NOT NULL,
            animation varchar(10) NOT NULL,
            speed int(10) NOT NULL,
            autoplay varchar(10) NOT NULL,
            cuboid int(10) NOT NULL,
            disperse int(10) NOT NULL,
            sequential int(10) NOT NULL,
            navigation varchar(10) NOT NULL,
            PRIMARY KEY(id)
  	      );';

    $wpdb->query($query);

    $image_gallery = $wpdb->prefix. 'image_3d_gallery';

    $query1 = 'create table if not exists ' .$image_gallery. '(
               ID int NOT NULL AUTO_INCREMENT,
               galleryid int(10) NOT NULL,
               galleryattachment int(10) NOT NULL,
               PRIMARY KEY(ID)
    );';

    $wpdb->query($query1);
}

register_activation_hook(__FILE__,'cwd_create_gallery');


function cwd_clear_gallery()
{
    global $wpdb;

    $image_gallery_details = $wpdb->prefix . 'image_3d';

    $wpdb->query("drop table '".$image_gallery_details."' ");

    $image_gallery = $wpdb->prefix . 'image_3d_gallery';

    $wpdb->query("drop table'".$image_gallery."' ");


}


register_uninstall_hook(__FILE__,'cwd_clear_gallery');


add_action('wp_head','cwd_image_gallery_scripts');

function cwd_image_gallery_scripts()
{

    wp_enqueue_script('jquery-custom','http://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js');
    wp_enqueue_script('modernizer',plugins_url('/js/modernizr.custom.46884.js',__FILE__),array('jquery'),false);
    wp_enqueue_script('slice',plugins_url('/js/jquery.slicebox.js',__FILE__),array('jquery'),false);

    wp_enqueue_style('custom',plugins_url('/css/custom.css',__FILE__));

}

add_action('admin_head','cwd_gallery_admin_scripts');

function cwd_gallery_admin_scripts()
{
    wp_enqueue_media();
    wp_enqueue_script('uploader', plugins_url('/js/uploader.js', __FILE__));
    $translation_array = array('url_ajax' => get_bloginfo("url") . "/wp-admin/admin-ajax.php");
    wp_localize_script('uploader', 'url', $translation_array);
}

add_action('admin_menu','for_display');

function for_display()
{
    add_menu_page('CWD 3D Image Gallery','CWD 3D Image gallery','manage_options','3d_image_gallery','for_upload',plugins_url('/images/menu.png',__FILE__));
}

function for_upload()
{

    echo '<h1 align="center" style="font-style: italic">CWD 3D Image Gallery</h1>';
    if(!$_REQUEST['action'])
    {
        global $wpdb;
        $image_gallery_details = $wpdb->prefix.'image_3d';
        $image_gallery = $wpdb->prefix.'image_3d_gallery';

        if($_POST['new_gallery'])
        {
            if($_POST['galleryname'])
            {

                $name = $_POST['galleryname'];

                $result = $wpdb->get_results("select *  from ".$image_gallery_details." where galleryname = '".$name."' ");

                if($result)
                {
                    echo "<div class='error'><p>Gallery already exists. Please choose gallery to insert images</p></div>";
                }
                else
                {

                    $res = $wpdb->query("insert into ".$image_gallery_details." values (NULL,'".$name."',600,400,'v',600,'false',4,30,150)");
                    echo "<div class='updated'><p>New Gallery Created</p></div>";


                }
            }
            else
            {
                echo "<div class='error'><p>Please enter gallery name</p></div>";
            }


        }
        $display = $wpdb->get_results("select * from ".$image_gallery_details." ");


        echo '<br><br>';
        echo '<form action="" method="post">';
        echo '<input type="text" name="galleryname" placeholder="Gallery name">&nbsp;&nbsp;&nbsp;';
        echo '<input type="submit" name="new_gallery" value="Create New Gallery" class="button-primary"><br><br>';
        if($display)
        {
        echo '<table class="wp-list-table widefat fixed posts ">';
        echo '<thead align="center">';
        echo '<th class="manage-column column-author" style="text-align: center" scope="col" id="first">Gallery Name</th>';
        echo '<th class="manage-column column-author" style="text-align: center" scope="col" id="first">ShortCode</th>';
        echo '<th class="manage-column column-author" style="text-align: center" scope="col" id="first">Action</th>';
        echo '</thead>';
        echo '<tbody align="center">';


        foreach($display as $disp)
        {
            echo '<tr>';
            $total = $wpdb->get_var("select count(galleryattachment) as t  from ".$image_gallery." where galleryid = ".$disp->id." ");
            echo '<td>'.$disp->galleryname.'&nbsp;('.$total.')'.'</td>';
            echo "<td>[3d_gallery id=$disp->id]</td>";
            ?>
            <td><a href="admin.php?page=3d_image_gallery&action=images&id=<?php echo $disp->id; ?>"><img src="<?php echo plugins_url('/images/view.png',__FILE__); ?>"> </a> &nbsp; <a href="admin.php?page=3d_image_gallery&action=settings&id=<?php echo $disp->id; ?>"><img src="<?php echo plugins_url('/images/settings.png',__FILE__); ?>"></a>&nbsp;  <a href="" ><img src="<?php echo plugins_url('images/delete.png',__FILE__); ?>" class="gallery_delete" data-id="<?php echo $disp->id; ?>"></a></td>
            <?php
            echo '</tr>';
        }
        echo '</tbody>';
        echo '</table>';
        }
        echo '</form>';

    }

    if($_REQUEST['action']=="images")
    {
        global $wpdb;
        $image_gallery_details = $wpdb->prefix.'image_3d';
        $image_gallery = $wpdb->prefix.'image_3d_gallery';

        $name = $_REQUEST['id'];
        $_SESSION['gallery_id']=$name;

        update_option('cwd_gallery_name',$name);
        $forname = $wpdb->get_results("select * from ".$image_gallery_details." where id = ".$_REQUEST['id']." ");

        foreach($forname as $gname)
        {
            echo "<h2 align='center'>$gname->galleryname</h2>";
            echo '<div class="updated"><p>If image is not displaying properly, kindly use regenerate thumbnails plugin to regenerate thumbnails and then try again!</p></div>';
        }
        ?>

        <br><br><br>
        <p align="center">
            <label for="upload_image">
                <input id="upload_image" type="text" size="36" name="ad_image" value="" class="hide_upload_image_textbox"/>
                <input id="upload_image_button" class="button button-primary" type="button" value="Upload Images" /><br>

            </label>
        </p>

        <?php

        $imageid = $wpdb->get_results("select * from ".$image_gallery." where galleryid = ".$_REQUEST['id']." ");

        echo  '<div  class="for_disp" style="">';
        if($imageid)
        {

            add_image_size("cwd_gallery",$imageid[0]->width,$imageid[0]->height,true);

            $i=0;


            foreach($imageid as $id1)
            {
                $displayid = $imageid[$i]->galleryattachment;
                $imageattr = wp_get_attachment_image_src($displayid,"thumbnail");

                if( $imageattr )
                {
                    ?>

                    <div class="img-single" style="float:left;padding:5px;position:relative;margin-right:10px;">
                        <img src="<?php echo plugins_url('images/close-button.png',__FILE__); ?>" class="fordel" style="position: absolute; left: 145px;top:5px;z-index:10;" data-id="<?php echo $id1->ID; ?>"><br>
                        <img src="<?php echo $imageattr[0]; ?>" width="<?php echo $imageattr[1]; ?>" height="<?php echo $imageattr[2]; ?>" data-id="<?php echo $displayid; ?>">
                    </div>

                <?php
                }
                $i++;
            }
        }
        echo '</div>';
    }

    if($_REQUEST['action']=="delete")
    {
        global $wpdb;
        $image_gallery_details = $wpdb->prefix.'image_3d';
        $image_gallery = $wpdb->prefix.'image_3d_gallery';

        $galleryid = $_REQUEST['id'];

        $del1 = $wpdb->query("delete from ".$image_gallery." where galleryid = ".$galleryid." ");
        $del = $wpdb->query("delete from ".$image_gallery_details." where id=".$galleryid." ");

        if($del && $del1)
        {
            echo "Deleted successfully";
        }
        else
        {
            echo "cannot be deleted";
        }
    }

    if($_REQUEST['action']=="settings")
    {
        global $wpdb;
        $image_gallery_details = $wpdb->prefix.'image_3d';
        $image_gallery = $wpdb->prefix.'image_3d_gallery';

        if($_POST['set_width_height'])
        {
            $gallery_id = $_REQUEST['id'];
            $width = $_POST['gallery_width'];
            $height = $_POST['gallery_height'];
            $animation = $_POST['animation_option'];
            $speed = $_POST['animation_speed'];
            $autoplay = $_POST['animation_autoplay'];
            $cuboid = $_POST['animation_cuboid'];
            $disperse = $_POST['animation_disperse'];
            $sequential = $_POST['animation_sequential'];

            $result = $wpdb->query("update ".$image_gallery_details."  set width=".$width.", height=".$height.",animation='".$animation."',speed=".$speed.",autoplay='".$autoplay."',cuboid='".$cuboid."',disperse='".$disperse."',sequential='".$sequential."' where id = '".$gallery_id."' ");
            if($result)
            {
                echo "<div class='updated'><p>Settings updated</p></div>";
            }
            else
            {
                echo "<div class='updated'><p>Default settings remain unchanged</p></div>";
            }


        }

        $image_details= $wpdb->get_results("select * from ".$image_gallery_details." where id=".$_REQUEST['id']." ");

        $get_images = $wpdb->get_results("select * from ".$image_gallery." where galleryid=".$_REQUEST['id']." ");
        if($get_images)
        {
            foreach($get_images as $img)
            {
                $check[] = $img->galleryattachment;
            }

            $check2 = implode(",",$check);
            //echo urlencode($check2);

            $url = wp_nonce_url( admin_url( 'tools.php?page=regenerate-thumbnails&goback=1&ids=' . urlencode($check2) ), 'regenerate-thumbnails' );
            echo "<div class='updated'><p>If the image sizes doesn't look correct, Click to <a href='".$url."'>Regenerate Thumbnails</a></p></div>";

            echo "<h2>".$image_details[0]->galleryname."</h2>";
        }

        ?>
        <form action="" method="post">
            <table id="cwd_image_settings">
                <input type="text" name="image_gallery_id" id="gallery_id1"  value="<?php echo $_REQUEST['id']; ?>"readonly class="hide_settings_id_cwd">
                <tr>
                    <td style="width: 200px;">Width : </td><td><input type="text" name="gallery_width" value="<?php echo $image_details[0]->width;  ?>">&nbsp;<i>Width of the image</i></td>
                </tr>
                <tr>
                    <td>Height : </td><td><input type="text" name="gallery_height" value="<?php echo $image_details[0]->height;  ?>">&nbsp;<i>Height of the image</i></td>
                </tr>
                <tr>
                    <td>Animation : </td><td><select name="animation_option">
                            <option value="v" <?php if($image_details[0]->animation=="v") {?> selected <?php } ?> >Vertical</option>
                            <option value="h"<?php if($image_details[0]->animation=="h") {?> selected <?php } ?>>Horizontal</option>
                            <option value="r"<?php if($image_details[0]->animation=="r") {?> selected <?php } ?>>Random</option>
                        </select><i>&nbsp;Animation Effect Vertical,Horizontal or Random</i></td>
                </tr>
                <tr>
                    <td>Speed (milliseconds) : </td><td><input type="text" name="animation_speed" value="<?php echo $image_details[0]->speed;  ?>">&nbsp;<i>1000 milliseconds = 1 second</i></td>
                </tr>
                <tr>
                    <td>Autoplay :</td><td><select name="animation_autoplay" class="cwd_image_gallery_autoplay">
                            <option value="true" <?php if($image_details[0]->autoplay=="true") {?> selected <?php } ?> >Yes</option>
                            <option value="false" <?php if($image_details[0]->autoplay=="false") {?> selected <?php } ?> >No</option>
                        </select><i>&nbsp;Autoplay on image load</i></td>
                </tr>
                <tr>
                    <td>Cuboids Count : </td><td><input type="text" name="animation_cuboid" value="<?php echo $image_details[0]->cuboid;  ?>"><i>Count of images to split</i></td>
                </tr>
                <tr>
                    <td>Disperse Factor :</td><td><input type="text" name="animation_disperse" value="<?php echo $image_details[0]->disperse;  ?>"><i>Animation effect default=30</i></td>
                </tr>
                <tr>
                    <td>Sequential Factor: </td><td><input type="text" name="animation_sequential" value="<?php echo $image_details[0]->sequential;  ?>"><i>Time between each rotation default=150</i></td>
                </tr>

            </table><br>
            <input type="submit" name="set_width_height" value="Set" class="button-primary cwd_image_settings_set" >

        </form>
    <?php
    }
}

function my_admin_notice()
{

    if(!is_plugin_active('regenerate-thumbnails/regenerate-thumbnails.php'))
    {
        ?>
        <div class="updated">
            <p><?php echo " <a href='http://wordpress.org/plugins/regenerate-thumbnails/'>Please install regenerate thumbnail plugin to use 3d image gallery. Click here to install regenerate thumbnails plugin</a>"; ?></p>
        </div>
    <?php
    }

}

add_action( 'admin_notices', 'my_admin_notice' );

add_action('wp_ajax_cwd_image_uploader','cwd_image_uploader');

function cwd_image_uploader()
{
    global $wpdb;
    $image_gallery_details = $wpdb->prefix.'image_3d';
    $image_gallery = $wpdb->prefix.'image_3d_gallery';

    $image_id = $_POST['id'];
    $gallery_id = $_SESSION['gallery_id'];

    foreach($image_id as $image)
    {

        $wpdb->query("insert into ".$image_gallery." values(NULL,".$gallery_id.",".$image.")");

        $imageattr = wp_get_attachment_image_src($image,"thumbnail");
        if( $imageattr )
        {
            ?>

            <div class="img-single" style="float:left;padding:5px;margin-right:10px;position:relative;">
                <img src="<?php echo plugins_url('images/close-button.png',__FILE__); ?>" class="fordel" style="position: absolute; left: 145px;top:5px;z-index:10;display:none;" data-id="<?php echo $displayid; ?>"><br>
                <img src="<?php echo $imageattr[0]; ?>" width="<?php echo $imageattr[1]; ?>" height="<?php echo $imageattr[2]; ?>">
            </div>
        <?php

        }
    }
    exit;

}

add_action('wp_ajax_cwd_image_delete','cwd_image_delete');

function cwd_image_delete()
{
    global $wpdb;
    $image_gallery_details = $wpdb->prefix.'image_3d';
    $image_gallery = $wpdb->prefix.'image_3d_gallery';

    $image_id = $_POST['image_id'];

    $ins = $wpdb->query("delete from ".$image_gallery." where ID = ".$image_id." ");

    exit;
}

add_action('wp_ajax_cwd_gallery_delete','cwd_gallery_delete');

function cwd_gallery_delete()
{
    global $wpdb;
    $image_gallery_details = $wpdb->prefix.'image_3d';
    $image_gallery = $wpdb->prefix.'image_3d_gallery';

    $gallery_id = $_POST['gallery_id'];

    $del1 = $wpdb->query("delete from ".$image_gallery." where galleryid = '".$gallery_id."' ");
    $del = $wpdb->query("delete from ".$image_gallery_details."  where id = '".$gallery_id."' ");

    exit;

}


global $wpdb;
$image_gallery_details = $wpdb->prefix.'image_3d';
$image_gallery = $wpdb->prefix.'image_3d_gallery';

$imageid = $wpdb->get_results("select * from ".$image_gallery_details." ");

if($imageid)
{
    foreach($imageid as $id1)
    {
        add_image_size("cwd_gallery".$id1->id,$id1->width,$id1->height,true);
    }

}


add_shortcode('3d_gallery','cwd_gallery');


function cwd_gallery($atts)
{
    if(!empty($atts))
    {
        extract($atts);

        global $wpdb;
        $image_gallery_details = $wpdb->prefix.'image_3d';
        $image_gallery = $wpdb->prefix.'image_3d_gallery';


        $imageid = $wpdb->get_results("select * from ".$image_gallery." where galleryid = ".$id." ");
        $count = $wpdb->get_var("select count(*) from ".$image_gallery." where galleryid = ".$id." ");
        $imagewidth = $wpdb->get_results("select * from ".$image_gallery_details." where id=".$id." ");

        if($imageid)
        {
            $i=0;


            ?>

            <div class="sb-slider-wrapper" style="width: <?php echo $imagewidth[0]->width; ?>px;">

                <ul id="sb-slider<?php echo $id; ?>" class="sb-slider">
                    <?php

                    foreach($imageid as $id1)
                    {
                        $displayid = $id1->galleryattachment;
                        $imageattr = wp_get_attachment_image_src($displayid,"cwd_gallery".$id);

                        if( $imageattr )
                        {
                            ?>
                            <li>
                                <img src="<?php echo $imageattr[0]; ?>" width="<?php echo $imageattr[1]; ?>" height="<?php echo $imageattr[2]; ?>">

                            </li>

                        <?php
                        }

                    }

                    ?>

                </ul>

                <div id="shadow<?php echo $id; ?>" class="shadow"></div>

                <div id="nav-arrows<?php echo $id; ?>" class="nav-arrows">
                    <a href="#">Next</a>
                    <a href="#">Previous</a>
                </div>

                <div id="nav-dots<?php echo $id; ?>" class="nav-dots">
                    <span class="nav-dot-current"></span>
                    <?php

                    for($j=1;$j<$count;$j++)
                    {
                        echo '<span></span>';
                    }


                    ?>

                </div>

            </div><!-- /wrapper -->

            <script>

                jQuery(function() {

                    var Page<?php echo $id; ?> = (function() {
                        choice = "<?php echo $imagewidth[$i]->animation; ?>";

                        var $navArrows = jQuery( '#nav-arrows<?php echo $id; ?>' ).hide(),
                            $navDots = jQuery( '#nav-dots<?php echo $id; ?>' ).hide(),
                            $nav = $navDots.children( 'span' ),
                            $shadow = jQuery( '#shadow<?php echo $id; ?>' ).hide(),
                            slicebox = jQuery( '#sb-slider<?php echo $id; ?>' ).slicebox( {
                                onReady : function() {

                                    $navArrows.show();
                                    $navDots.show();
                                    $shadow.show();

                                },


                                speed : <?php echo $imagewidth[$i]->speed; ?>,
                                orientation : choice,
                                autoplay :  <?php echo $imagewidth[$i]->autoplay; ?>,
                                cuboidsCount : <?php echo $imagewidth[$i]->cuboid; ?>,
                                disperseFactor : <?php echo $imagewidth[$i]->disperse; ?>,
                                sequentialFactor : <?php echo $imagewidth[$i]->sequential; ?>,


                                onBeforeChange : function( pos ) {

                                    $nav.removeClass( 'nav-dot-current' );
                                    $nav.eq( pos ).addClass( 'nav-dot-current' );

                                }
                            }),

                            init = function() {

                                initEvents();

                            },
                            initEvents = function() {

                                // add navigation events
                                $navArrows.children( ':first' ).on( 'click', function() {

                                    slicebox.next();
                                    return false;

                                } );

                                $navArrows.children( ':last' ).on( 'click', function() {

                                    slicebox.previous();
                                    return false;

                                } );

                                $nav.each( function( i ) {

                                    jQuery( this ).on( 'click', function( event ) {

                                        var $dot = jQuery( this );

                                        if( !slicebox.isActive() ) {

                                            $nav.removeClass( 'nav-dot-current' );
                                            $dot.addClass( 'nav-dot-current' );

                                        }

                                        slicebox.jump( i + 1 );
                                        return false;

                                    } );

                                } );

                            };

                        return { init : init };

                    })();

                    Page<?php echo $id; ?>.init();


                });






            </script>


            <?php
            $i++;
        }
        else
        {
            echo "<b>Gallery doesnot exist";
        }

    }

    else
    {
        echo "<b>Please enter gallery id in shortcode. See shortcode reference in plugin dashboard</b>";
    }

}

?>
